#include "StdAfx.h"
#include "gbadraw.h"

GbaDraw::GbaDraw(void)
{
}

GbaDraw::~GbaDraw(void)
{
}

HBITMAP GbaDraw::DrawImage(u8 *pUnCmpPal, u8 *pUnCmpData, int Rows, int Size)
{
	CImage m_bmpBitmap;
	m_bmpBitmap.Destroy();
	m_bmpBitmap.Create(64, 64, 8, 0);



int x=0;
int y=0;


		POINT point;
		point.x=x;
		point.y=y;


		u8 r[16];
		u8 g[16];
		u8 b[16];

		tagRGBQUAD colorref[16];


		for(int i=0; i<16; i++)
		{
			u16 palbuf=0 ;
			palbuf = pUnCmpPal[i*2+1]<<8;			
			palbuf = palbuf | pUnCmpPal[i*2];


			r[i] = ((palbuf & 0x1F) <<3);
			g[i] = ((palbuf >> 5) & 0x1F) <<3;
			b[i] = (((palbuf >> 10) & 0x1f) <<3);

	colorref[i].rgbBlue=(((palbuf >> 10) & 0x1f) <<3);
	colorref[i].rgbGreen=((palbuf >> 5) & 0x1F) <<3;
	colorref[i].rgbRed=((palbuf & 0x1F) <<3);
	colorref[i].rgbReserved=255;

		}

		m_bmpBitmap.SetColorTable(0, 16, colorref);
		


for(int w=0; w<8; w++)
{

for(int q=0; q<8; q++)
{

		for(int i=0; i<8; i++)
		{
		
		for(int j=0; j<4; j++)
		{
		unsigned char byte;
		unsigned char color1;
		unsigned char color2;
		
		byte = pUnCmpData[j+i*4+q*32+w*256];
		color1 = (byte >> 4) & 0x0F;
		color2 = byte & 0x0F;
		m_bmpBitmap.SetPixel(point.x, point.y, RGB(r[color2], g[color2],b[color2]) );
		point.x++;
		m_bmpBitmap.SetPixel(point.x, point.y, RGB(r[color1], g[color1],b[color1])) ;
		point.x++;
		}
        point.y++;
		point.x-=8;
		}
 point.x+=8;
 point.y-=8;

}
 point.x-=64;
 point.y+=8;
}

m_bmpBitmap.Save("testmepls.png");
return static_cast <HBITMAP>(m_bmpBitmap);

}
